Unit CRT22;
(*
        Leegyszerstett konzol/file input/output rutinkszlet.
        A program (amelyhez fordtottk) elindulsakor ellenrzi
        paramtereit. Ha van, akkor azokat input-, ill. outputfile-
        nvknt rtelmezi. Teht a program indtsa:

                program.exe [inpfile [outfile]]

        Pl.:
                crt2prob.exe inp.txt out.txt

        Magyarzat a paramterekhez:
        0 paramter => input=konzol output=konzol
        1 paramter => input=file/konzol output=konzol
          Az input file megnyitsi hiba esetn, automatikusan a konzol.
        2 paramter => input=file/konzol output=file/konzol
          A file/konzol esetben dinamikusan lehet vlasztani a paramterrel
          definilt file s a konzol kztt.
*)

Interface
  Uses Newdelay,Crt;

  Const     CrLf=#13#10;
  Procedure UjLap(cim:String; varakozas{lapozs eltt}:Integer{sec.-ban});
  Procedure FileInput(s: String);
  Function  MiazInput:String;
  Procedure FileOutput(s: String);
  Function  MiazOutput:String;
  Procedure KonzolInput;
  Procedure KonzolOutput;
  Procedure BillreVar;

Implementation

  Var
    IFilenev,
    OFilenev : String;
    SaveExit : Pointer;

  Procedure UjLap(cim:String; varakozas{lapozs eltt}:Integer{sec.-ban});
  Begin
    If MiAzOutput='' then {konzol}
    Begin
      If varakozas<0 then {vrakozas billentyletsig} ReadKey
                     else Delay(varakozas*100);
    End;
    ClrScr; Writeln(cim:40+Length(cim) Div 2);
  End;

  Procedure Uzenet(s :string); forward;

  Procedure FileInput(s: String);
  Begin
    If s<>'' then IFileNev:=s;
    {$I-}
    Assign(Input,IFileNev); Reset(Input);
    If IOResult<>0 then
    Begin
        Uzenet('Nem tudom az input file-t megnyitni, konzolrl olvasok...');
        KonzolInput;
    End;
    {$I+}
  End;

  Function MiazInput:String;
  Begin
    MiazInput:=IFileNev
  End;

  Procedure FileOutput(s: String);
  Begin
    Close(Output);
    If s<>'' then OFileNev:=s;
    {$i-}
    Assign(Output,OFileNev); Reset(Output);
    {$i+}
    If IOResult<>0 then Rewrite(Output)
                   else Append(Output);
  End;

  Function MiazOutput:String;
  Begin
    MiazOutput:=OFileNev
  End;

  Procedure KonzolInput;
  Begin
    {Close(fInput);} Assign(Input,'CON'); Reset(Input);
  End;

  Procedure KonzolOutput;
  Begin
    Close(Output); Assign(Output,'CON'); Rewrite(Output);
  End;

  Procedure BillreVar;
    Var
      c: Char;
  Begin
    c:=ReadKey;
  End;

  Procedure Uzenet(s :string);

    Const ablakszel=75;
          VarSzoveg='ssn le egy billentyt!';
    Type  Tkep=array[1..80,1..25] of record mi,attrib:byte end;
    Var   kep:Tkep absolute $B800:$0000;
          ment:Tkep;

    Procedure Uzenetinic;
    Begin
      ment:=kep;
      Window(3,3,ablakszel,5);
      Textbackground(Red); Textcolor(White); ClrScr;
    End;

    Procedure Vissza;
    Begin
      NormVideo;
      Window(1,1,80,25);
      kep:=ment;
    End;

  Begin
    Uzenetinic;

    Writeln(s:(ablakszel+Length(s)) div 2);
    Writeln;
    Write(VarSzoveg:((ablakszel+Length(VarSzoveg)) div 2));

    BillreVar;
    Vissza;
  End;

  Procedure MyExitProc; far;
  begin
     If (ExitCode<>0) and (ErrorAddr<>nil) then
     Begin
       Uzenet('Hiba trtnt!');
(*       ErrorAddr:=nil;     { nem ir ki run time error-t}*)
     End;
     ExitProc:=SaveExit;     { eredeti kilpsi eljrsokat is vgrehajtja }
  End;

Begin
                        {mindenfajta futsi hiba esetn sajt hibarutin indul}
  If ParamCount in [1..2] then
  Begin
    SaveExit:=ExitProc;
    ExitProc:=@MyExitProc;                  {sajt exit proc belltsa}
  End;
  Case ParamCount of
    0 : Begin
          KonzolInput; KonzolOutput
        End;
    1 : Begin
          Uzenet('File-Input: "'+ParamStr(1)+'"!!!');
          FileInput(ParamStr(1));
          KonzolOutput
        End;
    2 : Begin
          Uzenet('File-Input: "'+ParamStr(1)+'"!!!');
          FileInput(ParamStr(1));
          {$i-}
          Uzenet('File-Output: "'+ParamStr(2)+'"!!!');
          Assign(Output,ParamStr(2)); Reset(Output);
          {$i+}
          If IOResult=0 then Erase(Output) else Rewrite(Output);
          FileOutput(ParamStr(2))
        End;
  End;
End.